<?php
class ControllerPaymentpas extends Controller {
	protected function index() {
	
	
		$this->language->load('payment/pas');
    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
	
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		$this->load->library('encryption');
			
		$encryption = new Encryption($this->config->get('config_encryption'));
		$this->data['amount'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

		
		$this->data['order_id'] = $this->session->data['order_id'];
		$this->data['back'] = $this->url->https('checkout/payment', '', 'SSL');
		$amount = $this->data['amount'];
		
		if($this->currency->getCode()!='RLS') {
		    $this->data['amount'] = $amount * 10;
	    }
		
        $this->data['order_id'] = $this->session->data['order_id'];
		$this->data['redirect_url']  =  ($this->url->https('payment/pas/callback','', 'SSL'));
		$this->data['action'] = "https://mabna.shaparak.ir:8080";
		$this->id       = 'payment';
		
		$amount = trim($this->data['amount']);
		$terminal = $this->config->get('sha1Key');
		$invoiceNumber = time();
		$redirectAddress= $this->data['redirect_url'];
		

		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				$this->data['TerminalID']=$terminal;
				$this->data['token']=$res['Accesstoken'];
				$_SESSION['order_id'] = $this->data['order_id'];
				if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/pas.tpl')) 
				{
					$this->template = $this->config->get('config_template') . '/template/payment/pas.tpl';
				} else 
				{
					$this->template = 'default/template/payment/pas.tpl';
				}
				$this->render();
				
			}else
			{
				echo ('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
				die;
			}
		}else
		{
			echo('پورت 8081 در هاست شما بسته است !');
			die;
		}
	
		
		
	}

	public function callback() 
	{
		$this->language->load('payment/pas');
		@session_start();
		$order_id = $_SESSION['order_id'];
		$resultCode = $this->request->post['resultCode'];

	
		
		$this->data['text_wait'] = $this->language->get('text_wait');
		$this->data['text_heading'] = $this->language->get('text_heading');
		$this->data['text_results'] = $this->language->get('text_results');
		$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_continue'] = $this->language->get('button_continue');
		$this->data['breadcrumbs'] = array();
		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_home'), 'href' => $this->url->https('common/home', '', 'SSL'), 'separator' => false);
		$this->data['breadcrumbs'][] = array('text' => $this->language->get('text_heading'), 'href' => $this->url->https('payment/pas/callback', '', 'SSL'), 'separator' => $this->language->get('text_separator'));
		$this->data['error_warning'] = '';
		
		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$merchant = $this->config->get('sha1Key');

			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($order_id);
			
			$amount = @$this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE);	
			
			if($this->currency->getCode()!='RLS') 
			{
				$amount = $amount * 10;
			}
			

			
			if ($order_info) 
			{
				$_POST['digitalreceipt'] = $this->db->escape($this->request->post["digitalreceipt"]);
				$order_history = $this->db->query("SELECT count(*) as cc FROM order_history WHERE comment = '" .$_POST['digitalreceipt']. "'");
				if ($order_history->num_rows && $order_history->row['cc'] == 0) 
				{
					$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$merchant;
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
					curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					$res = curl_exec($ch);
					curl_close($ch);
					$result = json_decode($res,true);
					if (strtoupper($result['Status']) == 'OK') 
					{
						
						if(floatval($result['ReturnId'])  == floatval($amount))
						{
								$referenceId = $_POST['digitalreceipt'];
								$this->data['authority'] = $referenceId;
								$this->data['continue'] = $this->url->https('checkout/success');
								$this->model_checkout_order->confirm($order_id, $this->config->get('pas_order_status_id'),$referenceId);
								$this->response->setOutput('<html><head><meta http-equiv="refresh" CONTENT="2; url=index.php?route=checkout/success"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1576;&#1575; &#1578;&#1588;&#1705;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1578;&#1705;&#1605;&#1740;&#1604; &#1588;&#1583;. &#1604;&#1591;&#1601;&#1575; &#1670;&#1606;&#1583; &#1604;&#1581;&#1592;&#1607; &#1589;&#1576;&#1585; &#1705;&#1606;&#1740;&#1583; &#1608; &#1740;&#1575; <a href="index.php?route=checkout/success"><b>&#1575;&#1740;&#1606;&#1580;&#1575; &#1705;&#1604;&#1740;&#1705; &#1606;&#1605;&#1575;&#1740;&#1740;&#1583;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
				
							}
							else
							{
								$this->data['error_warning'] = 'مبلغ واریز و مبلغ سفارش برابر نیست';
								$this->data['continue'] = $this->url->https('checkout/checkout');
								$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
							}
						 }
						 else
						{
							switch($result['ReturnId'])
							{
								case '-1' : $res = 'تراکنش پیدا نشد';break;
								case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
								case '-3' : $res = 'خطا عمومی';break;
								case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
								case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
								default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
								
							}
							$this->data['error_warning'] = $res;
							$this->data['continue'] = $this->url->https('checkout/checkout');
							$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
						}
					}
					else
					{
						$this->data['error_warning'] = 'رسید قبلا استفاده شده است';
						$this->data['continue'] = $this->url->https('checkout/checkout');
						$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
					}
				
				
			}
			else 
			{
				$this->data['error_warning'] ='سفارش یافت نشد';
				$this->data['continue'] = $this->url->https('checkout/checkout');
				$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
			}
		} 
		else 
		{
			$this->data['error_warning'] = $_POST['respmsg'];;
			$this->data['continue'] = $this->url->https('checkout/checkout');
			$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; : '.$this->data['error_warning'].'<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
		}
		
		

	}

}
?>